
public class List<A> {

	private Node<A> start;		//initialisiert den Start der Liste bzw des ersten knoten	
	
	private int size;			//initialisiert die größe der Liste bzw die variable dafür
	
	public List() {				//Konstrukter der die Startwertde der liste angibt
		this.start = null;		//Startwert für "start" ist "null"
		this.size = 0;			//Startwert für die größe alos "size" ist 0
	}
	
	public boolean isEmpty() {	//Methode für den test ob die liste leer ist
		if(size == 0) {	//solange die größe noch 0 ist
			return true;		//positiver ergebnis, dass die Liste leer ist
		} else {		//ansonsten
			return false;	 //negative ergebnis, ass die liste Werte enthält
		}
	}
	
	public void add(A wert) {											//Methode für das anfüger eines Wertes bzw Elementes an der Liste
		this.size++;											//erhöht die größe der liste um 1
		
		if(this.start == null) {							//wenn der Startwert noch "null" ist
			this.start = new Node<A>(wert);			//dann wird der Startwert zum ersten Knoten indem er den eingegebenen "wert" als Wert enthält
		} else { //ansonsten
			Node<A> current = this.start;		//der aktuelle Knoten bekommt den wert start
			while (current.next != null) {				//wärend der Startwert des nächsten knoten ungleich "null" ist
				current = current.next;				//geht er zum nächsten knoten
			}
			current.next = new Node<A>(wert);	//der nächste Knoten ist ein neuer mit dem Wert "wert"
		}
	}
	
	public void add(A wert, int ort) {			//Methode für das einfügen von neuen elementen bzw Werten
	        if(ort < size) {	//wenn der ort zu dem man will kleiner als die gesamtgröße der Liste ist
	        	size++; //größe der Liste wird um 1 erhöht
	        	if(ort < 2) {	//wenn der ort nicht nur kleiner als die gesamtgröße ist sondern auch noch kleiner als der zweite, also der erste wert der liste
	        		Node<A> Neu = new Node<A>(wert);	//neuer knoten der den eingegebenen wert als "wert" erhält um den dann an der richtigen stelle einzuschieben
	        		Neu.next = start;	//der neue Knoten wird zum start Knoten
	        		start = Neu;	//der "Neu.next" wird mit der Zeile drüber zu "Neu"
	        	} else {	//ansonsten
		            Node<A>  Neu  = new Node<A>(wert); //neuer Knoten wird erstellt  mit dem wert "wert"
		            Node<A> current = this.start; //der aktuelle knoten wird zum start Knoten
		            
		            int a = 0;			//neue variable zum hochzählen
			            
		            while (a != ort - 2) {	//während a ungleich dem hinzuzählenden ort - 2 ist
			            	current = current.next; //wird jedes mal wenn... 				  ...wird der nächste wert zum aktuellen
			            	a++; 									   //...a um 1 erhöht wird...
			            }
		            
		            Neu.next = current.next; 	//der nächste wert vom neuen knoten wird zum nächsten wert vom aktuellen knoten
			        current.next = Neu;			//und der nächste wert vom aktuellen Knoten wird zum wert vom neuen knoten
	        	}
	        } else {		//ansonsten
	        	add(wert);		//wird der Wert einfach hinten angefügt mit der dazu bereits bestehenden Methode
	        }
		}	
	
	
	public A get(int ort) {	//Methode um den Wert an einer bestimmten stelle zu bekommen
		
		Node<A> current = this.start;		//Knoten current wird initialisiert
		
		for(int i = 0; i < ort; i++) {		//for schleife zum durchgehen der liste
			current = current.next;				//macht den nächsten wert zum aktuellen
		}
		A I = current.wert;			//speichert den Wert in einer Variable
		return I;			//gibt die variable zurück
	}
	
	public boolean contains(A wert) {									//Methode um herauszufinden ob ein bestimmter wert in der Liste vorhanden ist
		Node<A> current = this.start;									//initialisiert den knoten current
		while(current != null) {										//wärend der wert von current ungleicht "null" ist
		
			if(current.wert == wert) {									//wenn der Wert von current gleich dem eingegebenen "wert" ist
				return true;											//positives ergebnis für den durchgeführten test
			}
			current = current.next; 									//nächste wert von current wird zum aktuellen
		
		}
		return false;	//negatives ergebnis für den durchgeführten test
	}
		
	public A remove(int ort) {							//methode um dne wert an einer bestimmten stelle zu entfernen
		Node<A> current = this.start;					//initialisiert den Knoten current
		if(ort > size){									//wenn der ort nicht in der Liste ist null zurück geben
			return null;
		}
		if(ort > 1) {										//wenn der ort kleiner als 1 ist
			int f = 1;										//duchrchzählvariable
			while(f != ort-1) {								//während die variable ungleich dem ort - 1 ist
				current = current.next;						//wird der nächste wert zum aktuallen
				f++;										//f wird um 1 hochgezählt
			}
			current.next = current.next.next;				//der nächste wert ist der übernächste wert
			size--; 										//1 von der größe abziehen da ja ein wert entfernt wird
		} else { 											//ansonsten
		this.start = current.next;							//start wird zum nächsten wert vom aktuellen knoten aus
		}
		A I = current.wert;
		return I;
	}
	
	public Node<A> getStart() { //erstellt start zum getten
		return this.start;		//gibt start zurück
	}
	
	public int size() {	//erstellt size zum getten
		return this.size;	//gibt size zurück
	}
	
	public void Ausgabe() {
		Node<A> current = this.start;	//initialisiert die liste
				
			while(current != null) {	//solange current also der aktuelle Wert ungleich "null" ist
				System.out.print(current.wert + " ");	//gibt den aktuellen Wert aus
				current = current.next;	//geht zum nächsten Wert
			}
	}
	
}

