
public class Queue<Q> {
	
	private Node<Q> start;		//initialisiert den Start der Liste bzw des ersten knoten	
		
		private int size;			//initialisiert die größe der Liste bzw die variable dafür
		
		public Queue() {				//Konstrukter der die Startwertde der liste angibt
			this.start = null;		//Startwert für "start" ist "null"
			this.size = 0;			//Startwert für die größe alos "size" ist 0
		}
	
	public boolean isEmpty() {	//Methode für den test ob die liste leer ist
		if(size == 0) {	//solange die größe noch 0 ist
			return true;		//positiver ergebnis, dass die Liste leer ist
		} else {		//ansonsten
			return false;	 //negative ergebnis, ass die liste Werte enthält
		}
	}
	
	public void enqueue(Q wert) {//Methode für das anfüger eines Wertes bzw Elementes an der Queue
	this.size++;			//erhöht die größe der liste um 1
			
			if(this.start == null) {	//wenn der Startwert noch "null" ist
				this.start = new Node<Q>(wert);	//dann wird der Startwert zum ersten Knoten indem er den eingegebenen "wert" als Wert enthält
			} else { //ansonsten
				Node<Q> current = this.start;	//der aktuelle Knoten bekommt den wert start
				while (current.next != null) {	//wärend der Startwert des nächsten knoten ungleich "null" ist
					current = current.next;	//geht er zum nächsten knoten
				}
				current.next = new Node<Q>(wert);	//der nächste Knoten ist ein neuer mit dem Wert "wert"
			}
	}
	
	public Q dequeue() {		//Methode löscht den ertsen wert und gibt ihn zurück oder gibt "null" zurück
		Node<Q> current = this.start;	//initialisiert den Knoten current
		if(isEmpty() == true) {			//wenn das Ergebnis aus isEmpty() true ist...
			return null;																//...stoppt er
		} else { //ansonsten
			Q I = current.wert;			//speichert den wert in I
			this.start = current.next;	//start wird zum nächsten wert vom aktuellen Knoten aus
			return I;					//gibt den wert zurück
		}
	}
	
	public Q front() { //Methode gibt den ertsen wert zurück oder "null" 
		Node<Q> current = this.start;	//initialisiert den Knoten current
		if(isEmpty() == true) {	//wenn das Ergebnis aus isEmpty() true ist...
			return null;														//...stoppt er
		} else {
			Q I = current.wert;	//speichert den wert in I 
			return I;			// gibt den wert zurück
		}
	}
	
	public Node<Q> getStart() { //erstellt start zum getten
		return this.start;		//gibt start zurück
	}
	
	public int size() {	//erstellt size zum getten
		return this.size;	//gibt size zurück
	}
	
	public void Ausgabe() {
		Node<Q> current = this.start;	//initialisiert die liste
				
			while(current != null) {	//solange current also der aktuelle Wert ungleich "null" ist
				System.out.print(current.wert + " ");	//gibt den aktuellen Wert aus
				current = current.next;	//geht zum nächsten Wert
			}
	}
	
}
