
public class Set<X> {

	private Node<X> start;	
	
	private int size; //variable fr die gre
	
	public Set() {			//Konstrukter der die Startwertde der liste angibt
		this.start = null;		//Startwert für "start" ist "null"
		this.size = 0;			//Startwert für die größe alos "size" ist 0
	}
	
	public boolean isEmpty() {	//Methode für den test ob die liste leer ist
		if(size == 0) {	//solange die größe noch 0 ist
			return true;		//positiver ergebnis, dass die Liste leer ist
		} else {		//ansonsten
			return false;	 //negative ergebnis, ass die liste Werte enthält
		}
	}
	
	public boolean contains(X wert) {									//Methode um herauszufinden ob ein bestimmter wert in der Liste vorhanden ist
		Node<X> current = this.start;									//initialisiert den knoten current
		while(current != null) {										//wärend der wert von current ungleicht "null" ist
		
			if(current.wert == wert) {									//wenn der Wert von current gleich dem eingegebenen "wert" ist
				return true;											//positives ergebnis für den durchgeführten test
			}
			current = current.next; 									//nächste wert von current wird zum aktuellen
		
		}
		return false;	//negatives ergebnis für den durchgeführten test
	}
	
	public void add(X wert) {
		if(contains(wert) == false) {
			this.size++;											
			
			if(this.start == null) {							
				this.start = new Node<X>(wert);			
			} else { 
				Node<X> current = this.start;		
				while (current.next != null) {				
					current = current.next;	
	
				}
				current.next = new Node<X>(wert);
			}
			
		} else {
			return;
		}
		
	}
	
	public void remove(X wert) {//methode um dne wert an einer bestimmten stelle zu entfernen
		Node<X> current = this.start;//initialisiert den Knoten current
		if(current.wert == wert) {	//wenn der aktuelle wert dem eingegebenen entspricht
			this.start = current.next;	//wird der start zur nchsten variable
			size--;	//1 wind von der gre subtrahiert
		}
			while(current.next != null) {	//wrend die nchste variable ungleich null ist
				if(current.next.wert == wert) {	//wenn der nchste wert gleich dem eingegebenen wert ist
					current.next = current.next.next;	//wird die nchste variable zur bernchsten
					size--;	//1 wird von der gre abgezogen
				} else {	//ansonsten
					current = current.next;	//wird der aktuelle wert zum nchsten
				}
			
			}
	}
	
	public Set<X> intersection(Set<X> s) {
		Set<X> result = new Set<X>();
		Node<X> current = this.start;
		while(current != null) {
			if(s.contains(current.wert)) result.add(current.wert);
			current = current.next;
		}
		return result;
	}
	
	//public Set<X> union(Set<X> s) {
		

	//}
	
	/*public Set<X> difference(Set<X> s) {
		
	}
	
	public Set<X> subset(Set<X> s) {
		
	} */
	
	public Node<X> getStart() { //erstellt start zum getten
		return this.start;		//gibt start zurück
	}
	
	public int size() {	//erstellt size zum getten
		return this.size;	//gibt size zurück
	}
	
	public void Ausgabe() {
		Node<X> current = this.start;	//initialisiert die liste
		
	while(current != null) {	//solange current also der aktuelle Wert ungleich "null" ist
		System.out.print(current.wert + " ");	//gibt den aktuellen Wert aus
		current = current.next;	//geht zum nächsten Wert
	}System.out.print("\n");
}
	
}
